import QtQuick 2.12
import QtQuick.Layouts 1.3
import StorageMgr 1.0
import Process 0.1
import ".."
import Components 1.0
import QtQuick.Controls 2.12
import QtQuick.Controls.Styles 1.4
//import VLCVideo 1.0



Item {
    id:root
    property bool viewShowing:false
   property bool isSelected :currentViewName==="MIRROR_VIEW"
    property bool isMenuDisplayed: false
    property bool isMenuMoving : false
    property var msg:"USE CAST OPTION IN YOUR PHONE TO CONNECT TO TRUE-DEVICE"
    property var counter:0
    property bool showButton:false
   // property bool disconnect:false

    objectName: "MIRROR_VIEW"
    signal stopped()
    signal menuButtonPressed()

        signal action()
    function shown()
    {
        // msg="USE CAST OPTION IN YOUR PHONE TO CONNECT TO TRUE_DEVICE"
        root.viewShowing=true
        workoutViewContainer.persistMenu = true;
        counter=0;
        showButton=false

        demoParent.visible=false
        stopWifi.start()
       // BusyIndicator.visible=false
        startTV()
        //demoParent.visible=false
        /*if(tv.disconnectwifi===false)
        {
            // msg=""
            circleFill.start()
            control.visible=true

            //startTvTimer.start()
            //tv.on=true
            startTV()
        }
        else
        {
            stopWifi.start()
           }*/
    }
    function hidden()
    {
        root.viewShowing = false;
        workoutViewContainer.persistMenu = false;

        tv.on=false
        tv.stop()
        }

    Timer
    {
        id: circleFill

        interval: 500
        repeat: false
        onTriggered:
        {

        }
}

    Timer
    {
        id:afterDisconnect
        interval: 1000
        repeat: false
        onTriggered:
        {
            msg="USE CAST OPTION IN YOUR PHONE TO CONNECT TO TRUE_DEVICE"
        }
    }



    function startTV()
    {
       tv.on=true
        demoParent.visible=false
    }


    Process
    {
        id:stopWifi
        program: "scripts/disconnect_wifi.sh"
        onReadyReadStandardOutput: {
            var output = String(readAllStandardOutput())
            output = output.trim()
            console.log( "disconnect wifi ******************************* = " + output)
            if(output==="Disconnected")
            {
                startMirroring.start()
            }

        }
        onReadyReadStandardError: {
            var output = String(readAllStandardError())
            output = output.trim()
            console.log( "disconnect wifi :::::::::::::::::::::::::::::::::::::::::::::::::::::::" + output)
        }

    }
Component.onCompleted:
{
    tv.viewParent = demoParent
    tv.changeParent(demoParent)

}



     Process
    {
        id: startMirroring
        program: "scripts/miracle.exp"
        onReadyReadStandardOutput: {
            tv.disconnectwifi=false
            var output = String(readAllStandardOutput())
            output = output.trim()
            console.log( "******************************* = " + output)
            if(output==="add")
            {
                msg="FOUND A DEVICE PLEASE CONNECT TO TRUE_DEVICE"
            }

            if(output==="connect")
            {
                msg= "DEVICE CONNECTED WAITING FOR DEVICE"
                console.log("MSG:::::::::::",msg)
              //  control.visible=true
                //circleFill.start()
               tv.viewParent = phoneBackground
               tv.changeParent(phoneBackground)
                //startTV()
            }
            if(output==="Device")
            {
               // startTvTimer.start()
               // startTV()

            }

            if(output==="disconnect")
            {
                tv.on=false
                tv.stop()
                msg="NO DEVICE CONNECTED"
             // tv.disconnectwifi=true
                afterDisconnect.start()
               // stopMiracle.start()
                tv.changeParent(demoParent)

            }
        }
        onReadyReadStandardError: {
            var output = String(readAllStandardError())
            output = output.trim()
            console.log( "audioDeviceNumberDetect process (STDERR):::::::::::::::::::::::::::::::::::::::::::::::::::::::" + output)
        }

    }
    Rectangle
     {
         color: main.colorDialogBackground
         anchors.fill: parent
         border.color: main.colorUIBorder
         border.width: main.widthBorder
     }


    RowLayout
    {
        id:tvRow
        anchors.fill: parent
        anchors.margins: 1.5* main.widthBorder
        spacing :0
        visible: true


    Item {
        id:controlArea
        Layout.preferredWidth: root.width*0.15
        Layout.preferredHeight: root.height/2
        Layout.margins: 10 * main.scaleFactor
        Layout.alignment: Qt.AlignBottom
        visible: !root.fullscreen && isMenuDisplayed // && showButton
        ColumnLayout {
            id: controlGrid
            anchors.fill: parent
            spacing: 10 * main.vScaleFactor

            property real delegateWidth: width
            property real delegateHeight: (height-spacing)/(controlsListCab.count+1)

            Repeater {
                model: controlsListCab
                delegate: controlButtonDelegate
            }

            Component {
                id: controlButtonDelegate

                Item {
                    Layout.preferredWidth: controlGrid.delegateWidth
                    Layout.preferredHeight: controlGrid.delegateHeight

                    StandardButton {
                        anchors.fill: parent
                        sourceName: model.iconPath
                        buttonText: qsTr(model.label) + application.emptyString
                        selected: (volume_controls.muted && model.name === "VolumeMute")
                        color: selected ? main.colorSelected : main.colorDialogBackground
                        onClicked: {
                            controlClicked(model.name)
                            root.action()
                        }
                    }
                }

            }


           /* StandardButton
            {
                id:tvFullScreenButton
                Layout.fillWidth: true
                Layout.preferredHeight: 0.8*parent.width/3
                //buttonText: qsTr("FULL SCreen")+application.emptyString
                icon.sourceName: "Media/expand_icon_480"
                enabled:true
                onClicked:
                {
                    tv.showScreen()
                   }
            }*/

        } // end ColumnLayout

    }

    Item
    {
        id:phoneBackground
        Layout.fillHeight: true
        Layout.fillWidth: true
        Rectangle
        {
            id:phoneNotConnected
            anchors.fill: parent
            color: "black"
            visible: true
            ColumnLayout
            {
                id: showmsg
               // anchors.fill: parent
               // anchors.centerIn: parent
                anchors.horizontalCenter: phoneNotConnected.horizontalCenter
                anchors.verticalCenter: phoneNotConnected.verticalCenter
                spacing:10
                visible: true

                Text{
                    id:addDevice
                    Layout.fillHeight: true
                    Layout.fillWidth: true
                    Layout.alignment: Qt.AlignCenter
                    visible: true
                    text:msg
                    font.pixelSize: 20 * main.vScaleFactor
                    font.family: "Free Sans"
                    font.bold:  true
                    color: main.colorFontLight
                }

  /* BusyIndicator {
                    id: control
                    z: parent.z + 1
                    Layout.fillHeight: true
                    Layout.fillWidth: true
                    Layout.alignment: Qt.AlignCenter
                    /*anchors {
                        horizontalCenter: parent.horizontalCenter
                        verticalCenter: parent.verticalCenter
                        verticalCenterOffset: parent.height/4
                    }*/
                   /* width: 65
                    height: 65
                    visible: false

                    running: parent.visible
                    contentItem: Item {
                         implicitWidth: 64
                         implicitHeight: 64

                         Item {
                             id: item
                             x: parent.width / 2 - 32
                             y: parent.height / 2 - 32
                             width: 64
                             height: 64
                             opacity: control.running ? 1 : 0

                             Behavior on opacity {
                                 OpacityAnimator {
                                     duration: 250
                                 }
                             }

                             RotationAnimator {
                                 target: item
                                 running: control.visible && control.running
                                 from: 0
                                 to: 360
                                 loops: Animation.Infinite
                                 duration: 1250
                             }

                             Image {
                                 visible: control.running
                                 source: "../graphics/ui3_0/Components/busyIndicator.png"
                                 fillMode: Image.PreserveAspectFit
                                 RotationAnimator on rotation {
                                     running: control.running
                                     loops: Animation.Infinite
                                     duration: 2000
                                     from: 0
                                     to: 360
                                 }
                             }
                         }
                     }
                }*/

               /* Item
                {
                    id:showCircle
                    visible: false
                    //anchors.centerIn: parent
                   // anchors.bottom: addDevice
                   // anchors.bottomMargin: 50
                    Layout.fillHeight: true
                    Layout.fillWidth: true
                    Layout.alignment: Qt.AlignCenter
                   // width:50
                   // height: 50
                    Rectangle{
                        id:inMid
                        anchors.centerIn: parent
                    }

                }*/

            }
            }


        }
    }
   /* ProgressCircle
    {
        id:prgCircle
        size: 50

        visible: false
    }*/

    Item
    {
        id:demoParent
        visible: false
        width:0
        height:0
  }

    ListModel {
        id: controlsListCab



        ListElement {
            name: "VolumeDown"
            label: qsTr("VOL")
            iconPath: "Media/Media_Volume_Minus"
        }
        ListElement {
            name: "VolumeUp"
            label: qsTr("VOL")
            iconPath: "Media/Media_Volume_Plus"
        }

        ListElement {
            name: "VolumeMute"
            label: ""
            iconPath: "Media/Media_Mute_Up"
        }
        ListElement {
            name: "Fullscreen"
            label: ""
            iconPath: "Media/expand_icon_480"
        }
    }

    function controlClicked(name) {
        if(name === "VolumeDown") {
            volume_controls.volumeDown();
        } else if(name === "VolumeUp") {
            volume_controls.volumeUp();
        } else if(name === "VolumeMute") {
            volume_controls.toggleMute();
        }else if(name === "Fullscreen") {
            tv.showScreen()
        }
    }





}
