import QtQuick 2.12

Text {
    id: root
    text: root.textValue

    property string textValue: ""
    property int delay: 3000

    function setText(txt) {
        root.textValue = txt;
        hideTimer.restart();
    }

    Timer {
        id: hideTimer
        running: true
        repeat: false
        interval: root.delay
        onTriggered: {
            root.textValue = ""
        }
    }
}
