import QtQuick 2.12
import Components 1.0

Item {
    id: root
    width: main.width
    height: main.height

    Column {
        spacing: 30
        anchors.horizontalCenter: root.horizontalCenter
        anchors.verticalCenter: root.verticalCenter

        Text {
            text: qsTr("Setup Wizard") + application.emptyString
            font.bold: false
            font.pixelSize: 60
            horizontalAlignment: Text.AlignHCenter
            width:500
            height:100
        }

        Text {
            text: qsTr("Setup is now complete! Enjoy your machine!") + application.emptyString
            font.bold: false
            font.pixelSize: 30
            horizontalAlignment: Text.AlignHCenter
            width: 500
            height: 100
        }
    }
}
