import QtQuick 2.12
import Components 1.0

Item {
    id: root

    Column {
        spacing: 30 * main.vScaleFactor
        anchors.horizontalCenter: root.horizontalCenter
        anchors.verticalCenter: root.verticalCenter

        Text {
            text: qsTr("Setup Wizard") + application.emptyString
            font.bold: false
            font.pixelSize: 30 * main.vScaleFactor
            horizontalAlignment: Text.AlignHCenter
        }

        Text {
            text: qsTr("The setup wizard will step you through configuring the console for the first time") + application.emptyString
            font.bold: false
            font.pixelSize: 20 * main.vScaleFactor
            horizontalAlignment: Text.AlignHCenter
        }
    }
}
