import QtQuick 2.12
import ".."
import Components 1.0
import "../HomeScreen"

Item{
    id: facilitiesViewContainer

    property bool isMenuDisplayed: false
    property alias isMenuMoving: facilitiesView.isMenuMoving
    signal action()

    function shown() {
        facilitiesView.playing = true
    }

    function hidden() {
        facilitiesView.playing = false
    }

    Slideshow {
        id: facilitiesView
        slidesPath: "/data/facility"
        slidesUserPath: "/data/facility/user"

        anchors.fill: parent
        anchors.margins: main.widthBorder+1
        playing: false

        isMenuDisplayed: parent.isMenuDisplayed
        onAction: root.action()
    }
}
