#!/bin/bash
BASE_PATH=/data/video
OI_VIDEO_PATH="$BASE_PATH"/OI
VA_VIDEO_PATH="$BASE_PATH"

if [[ -d $OI_VIDEO_PATH ]]; then
  for vid in $OI_VIDEO_PATH/*.mp4 ; do

    ## Check if the glob gets expanded to existing files.
    ## If not, f here will be exactly the pattern above
    ## and the exists test will evaluate to false.
    [ -e "$vid" ] && echo "oi"
    ## This is all we needed to know, so we can break after the first iteration
    break
  done
elif [[ -d $VA_VIDEO_PATH ]]; then
  for vid in $VA_VIDEO_PATH/*.mp4 ; do
    [ -e "$vid" ] && echo "va" || echo "null"

    ## This is all we needed to know, so we can break after the first iteration
    break
 done
fi
